// Define the mutex for UART access
static SemaphoreHandle_t uart_mutex;

void init_uart_mutex() {
    uart_mutex = xSemaphoreCreateMutex();
    if (uart_mutex == NULL) {
        SEGGER_RTT_printf(0, "Failed to create UART mutex\n");
    }
}

static void rx_tx_function(void *pvParameter) {
    while (1) {
        // Try to acquire the mutex before UART operation
        if (xSemaphoreTake(uart_mutex, portMAX_DELAY) == pdTRUE) {
            // Perform UART operations
            DISPLAY_MODULE_UART_getCurrentDisplayedWindow(pCurrentWindow, pNumberCurrentWindow, pAll_OK);

            if (all_OK) {
                SEGGER_RTT_printf(0, "[INFO] - from->[%s()]->Current_Window = [%s]\n", __FUNCTION__, currentWindow);
                if (numberCurrentWindow != SKIPPED_WINDOW) {
                    SEGGER_RTT_printf(0, "[INFO] - from->[%s()]->NumberCurrentWindow = [%d]\n", __FUNCTION__, numberCurrentWindow);
                } else {
                    SEGGER_RTT_printf(0, "[INFO] - from->[%s()]->Skipped: [%s]\n", currentWindow);
                }
            } else {
                SEGGER_RTT_printf(0, "[INFO] - from->[%s()]->Handle timeoutTicks OR Failed to extract Current Window.\n", __FUNCTION__);
            }

            // Release the mutex after UART operation
            xSemaphoreGive(uart_mutex);
        }

        vTaskDelay(pdMS_TO_TICKS(10));
    }
}

static void rx_task_function(void *pvParameter) {
    while (1) {
        // Try to acquire the mutex before UART operation
        if (xSemaphoreTake(uart_mutex, portMAX_DELAY) == pdTRUE) {
            // Perform UART operations
            DISPLAY_MODULE_UART_printCurrentState(currentState.currentState);

            if (currentState.currentState == STATE_WHICH_BUTTON_WAS_PRESS) {
    
